﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Syncfusion.JavaScript;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;

namespace CoreRTE.Controllers
{
    public partial class RichTextEditorController : Controller
    {
        //
        // GET: /RTEDefault/
        public FileExplorerOperations operation;
        public ActionResult RichTextEditorFeatures()
        {
            return View();
        }
        public RichTextEditorController(IHostingEnvironment hostingEnvironment)
        {
            this.operation = new FileExplorerOperations(hostingEnvironment.ContentRootPath);
        }

        public ActionResult Upload(FileExplorerParams args)
        {
            operation.Upload(args.FileUpload, "/wwwroot" + args.Path);
            return Json("");
        }
        public ActionResult Download(FileExplorerParams args)
        {
            return operation.Download("/wwwroot" + args.Path, args.Names);
        }
        public ActionResult GetImage(FileExplorerParams args)
        {
            return operation.GetImage("/wwwroot" + args.Path);
        }

        public ActionResult FileActionDefault([FromBody] FileExplorerParams args)
        {
            var Path = "/wwwroot" + args.Path;
            try
            {
                if (args.ActionType != "Paste" && args.ActionType != "GetDetails")
                {
                    var FilePath = operation.GetPhysicalPath(Path);
                    if (!FilePath.ToLower().Contains("fileexplorercontent"))
                        throw new ArgumentException(FilePath + "is not accessible. Access is denied.");
                }

                switch (args.ActionType)
                {
                    case "Read":
                        return Json(operation.Read(Path, args.ExtensionsAllow));
                    case "CreateFolder":
                        return Json(operation.CreateFolder(Path, args.Name));
                    case "Paste":
                        return Json(operation.Paste(args.LocationFrom, args.LocationTo, args.Names, args.Action, args.CommonFiles));
                    case "Remove":
                        return Json(operation.Remove(args.Names, Path, args.SelectedItems));
                    case "Rename":
                        return Json(operation.Rename(Path, args.Name, args.NewName, args.CommonFiles));
                    case "GetDetails":
                        return Json(operation.GetDetails(Path, args.Names));
                    case "Search":
                        return Json(operation.Search(Path, args.ExtensionsAllow, args.SearchString, args.CaseSensitive));
                   
                }
                return Json("");
            }
            catch (Exception e)
            {
                FileExplorerResponse Response = new FileExplorerResponse();
                Response.error = e.GetType().FullName + ", " + e.Message;
                return Json(Response);
            }
        }

    }
}
